import org.scalacheck.Properties
import org.scalacheck.Prop.{forAll, BooleanOperators}
import org.scalacheck.Gen
import org.scalacheck.Arbitrary

object Dice56Specification extends Properties("Dice56") {

  // Attention quick'n'dirty...

  val Dices = new Dices(5,6)

  implicit def arbDice: Arbitrary[Dices.Dice] =
    Arbitrary {
      for {
        x1 <- Gen.choose(Dices.Face.min,Dices.Face.max)
        x2 <- Gen.choose(x1,Dices.Face.max)
        x3 <- Gen.choose(x2,Dices.Face.max)
        x4 <- Gen.choose(x3,Dices.Face.max)
        x5 <- Gen.choose(x4,Dices.Face.max)
        x6 <- Gen.choose(x5,Dices.Face.max)
      } yield new Dices.Dice(Vector(x1,x2,x3,x4,x5,x6))
    }

  property("compare-refl") = forAll { (a: Dices.Dice) =>
    a.compare(a) == 0
  }

  property(">>-irrefl") = forAll { (a: Dices.Dice) =>
    !(a >> a)
  }

  property(">>-antisym") = forAll { (a: Dices.Dice, b: Dices.Dice) =>
    !(a >> b && b >> a)
  }

  property(">>-!!trans") =
    forAll { (a: Dices.Dice, b: Dices.Dice, c: Dices.Dice) =>
      !(a >> b && b >> c && c >> a)
    }

  property(">>-trans") =
    forAll { (a: Dices.Dice, b: Dices.Dice, c: Dices.Dice) =>
      (a >> b) ==> (b >> c) ==> (a >> c)
    }

}
